/* --- --- ---

Elements of War
- by Curtis Turner <IceIYIaN>

e2DxPlayer > xPlayer > UnrealPlayer > PlayerController > Controller > Actor

Bugs:
- When users move their mouse up/down, the pawn moves forward/backward...
- When users switch to a different gametype, the view won't look/aim up/down...

Notes:
- vect(x, x, x) ... x = number
- First number does forward/backwards, second does left/right, third does up/down.

--- --- --- */

class e2DxPlayer extends xPlayer;

// Make it so pawns NEVER look/aim up/down.
event PostBeginPlay()
{
     Super.PostBeginPlay();
     
     bAlwaysMouseLook = False;
     bSnapToLevel = False;
}

/*
Camera
EoW isn't a FPS. Instead, it uses a Top/Down View where the pawn is in the middle
(moved down some now). The pawn will always look to the north(top of the screen).
When the player turns, the pawn and camera will rotate clockwise or counter-clockwise.
*/
event PlayerCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation)
{
// Set the camera location
     bBehindView = True;
     ViewActor = Self;
     ViewActor = ViewTarget;
     
     // Bug...  Fix, perhaps...
     CameraLocation = ViewTarget.Location;
     CameraLocation = ViewTarget.Location;
     CameraLocation = ViewTarget.Location;
     
     // Rotation makes the player's view and pawn the same(otherwise the pawn moves
     // all over the place(if the first two numbers are changed). Just leave it in.
     CameraLocation = ViewTarget.Location + (vect(0,0,1024) >> Rotation); // +256

// Set the camera and pawn to rotate clockwise/counter-clockwise
     // 0 - 4096 - 8192 - 16384 // Ahh, doubles of two... Should have known
     CameraRotation.Yaw = CameraRotation.Yaw;
     CameraRotation.Roll = CameraRotation.Roll;
     
     // Bug? Fix?
     CameraRotation.Pitch = CameraRotation.Pitch;
     CameraRotation.Pitch = CameraRotation.Pitch;
     CameraRotation.Pitch = CameraRotation.Pitch;
     
     CameraRotation.Pitch = -12288; // -16384
}

defaultproperties
{
     bBehindView=True
     SpectateSpeed=420.000000
     PawnClass=Class'EoW.e2DxPawn'

     bAdrenalineEnabled=False
     AdrenalineMax=999.000000
     MinAdrenalineCost=999.000000
     
     ComboNameList(0)=""
     ComboNameList(1)=""
     ComboNameList(2)=""
     ComboNameList(3)=""
}
