// Elements of War
class e2DxPlayer extends UTPlayerController
	dependson(UTPawn)
	dependson(UTCustomChar_Data)
	dependson(UTProfileSettings)
	config(Game);

event PostBeginPlay()
{
     Super.PostBeginPlay();
     
     SetCameraMode('ThirdPerson');
     bBehindView = True;
     bAlwaysMouseLook = False; // UT2003/4
     bSnapToLevel = False; // UT2003/4
}

// Find this and fix it
/*
reliable client function ClientSetBehindView(bool B)
{
bBehindView = True;
} // override so it wont reset

function SetBehindView(bool bNewBehindView)
{
bBehindView = True;
} // override so it wont reset
*/



simulated event GetPlayerViewPoint( out vector out_Location, out Rotator out_Rotation )
{
	local Actor TheViewTarget;



    		bBehindView = True;



	// sometimes the PlayerCamera can be none and we probably do not want this
	// so we will check to see if we have a CameraClass.  Having a CameraClass is
	// saying:  we want a camera so make certain one exists by spawning one
	if( PlayerCamera == None )
	{
		if( CameraClass != None )
		{
			// Associate Camera with PlayerController
			PlayerCamera = Spawn(CameraClass, Self);
			if( PlayerCamera != None )
			{
				PlayerCamera.InitializeFor( Self );
			}
			else
			{
				LogInternal("Couldn't Spawn Camera Actor for Player!!");
			}
		}
	}

	if( PlayerCamera != None )
	{
		PlayerCamera.GetCameraViewPoint(out_Location, out_Rotation);
	}
	else
	{
		TheViewTarget = GetViewTarget();

		if( TheViewTarget != None )
		{
			// Default
			// out_Location = TheViewTarget.Location;
			// out_Rotation = TheViewTarget.Rotation;



// Change the camera to EoW's
    	bBehindView = True;
	out_Location = TheViewTarget.Location + (vect(0,0,1024) >> Rotation);
	out_Rotation = TheViewTarget.Rotation + (rot(-12288,0,0));



		}
		else
		{
			super.GetPlayerViewPoint(out_Location, out_Rotation);
		}
	}
}



// Left here just in case we want to change it later
/**
 * Processes the player's ViewRotation
 * adds delta rot (player input), applies any limits and post-processing
 * returns the final ViewRotation set on PlayerController
 *
 * @param	DeltaTime, time since last frame
 * @param	ViewRotation, current player ViewRotation
 * @param	DeltaRot, player input added to ViewRotation
 */
function ProcessViewRotation( float DeltaTime, out Rotator out_ViewRotation, Rotator DeltaRot )
{
	if( PlayerCamera != None )
	{
		PlayerCamera.ProcessViewRotation( DeltaTime, out_ViewRotation, DeltaRot );
	}

	if ( Pawn != None )
	{	// Give the Pawn a chance to modify DeltaRot (limit view for ex.)
		Pawn.ProcessViewRotation( DeltaTime, out_ViewRotation, DeltaRot );
	}
	else
	{
		// If Pawn doesn't exist, limit view

		// Add Delta Rotation
		out_ViewRotation	+= DeltaRot;
		out_ViewRotation	 = LimitViewRotation(out_ViewRotation, -16384, 16383 );
	}
}


/* --- --- ---
Limit the player's view rotation. PITCH.
Note:
Pawn Default Prop also has pitch options.
--- --- --- */
event Rotator LimitViewRotation( Rotator ViewRotation, float ViewPitchMin, float ViewPitchMax )
{
	ViewRotation.Pitch = ViewRotation.Pitch & 0; // & 65535;

    if( ViewRotation.Pitch > ViewPitchMax &&
		ViewRotation.Pitch < (65535+ViewPitchMin) )
	{
		if( ViewRotation.Pitch < 32768 )
		{
			ViewRotation.Pitch = ViewPitchMax;
		}
		else
		{
			ViewRotation.Pitch = 65535 + ViewPitchMin;
		}
	}

	return ViewRotation;
}

defaultproperties
{
   bBehindView=True
}